import 'dart:convert';

import 'package:flutter_test/flutter_test.dart';
import 'package:workouttest_util/model/cache.dart';
import 'package:workouttest_util/service/api.dart';
import 'package:workouttest_util/service/webapi.dart';

main() {
  setUp(() {
    Cache().setLocalBaseUrl();
  });

  group('api', () {
    test('connect api auth successfully', () async {
      var api = APIClient();
      var responseJson = await api.authenticateUser("bosi", "andio2009");
      print(responseJson);
      Cache().authToken = responseJson['token'];
      final body = await api.get("app_package", "");
      print(body);
    });

    test('connect webapi auth successfully', () async {
      var api = APIWebClient();
      var responseJson = await api.authenticateUser("bosi", "andio2009");
      print(responseJson);
      Cache().authToken = responseJson['token'];
      final body = await api.get("app_package", "");
      print(body);
    });

    test('test customer conversation in utf8', () async {
      var api = APIWebClient();
      var responseJson = await api.authenticateUser("bosi", "andio2009");
      print(responseJson);
      Cache().authToken = responseJson['token'];
      final body = await api.get("customer_conversation/72", "");

      List<int> bytes3 = base64.decode(body);
      String decodedString = utf8.decode(bytes3);
      print(decodedString);

      final body2 = await api.get("meal/21", "");
      print(body2);
    });
  });
}
